;sD3DX_PI    equ 40490FDBh ;3.141592654f
;sD3DX_1BYPI equ 3EA2F983h ;0.318309886f

;D3DXToRadian macro degree:req
;    fldpi
;    fdiv fp180
;    fimul degree
;endm

;D3DXToDegree macro fradian:req
;    fld fp180
;    fdiv D3DX_PI
;    fmul fradian
;endm


; 
; Vectors

D3DXVECTOR2 struct
  x real4 ?
  y real4 ?
D3DXVECTOR2 ends
LPD3DXVECTOR2 typedef ptr D3DXVECTOR2
Vec2 equ <D3DXVECTOR2>

D3DXVECTOR3 struct
  x real4 ?
  y real4 ?
  z real4 ?
D3DXVECTOR3 ends
LPD3DXVECTOR3 typedef ptr D3DXVECTOR3
Vec3 equ <D3DXVECTOR3>

D3DXVECTOR4 struct
  x real4 ?
  y real4 ?
  z real4 ?
  w real4 ?
D3DXVECTOR4 ends
LPD3DXVECTOR4 typedef ptr D3DXVECTOR4
Vec4 equ <D3DXVECTOR4>


; 
; Matrices

D3DXMATRIX struct
  m00 real4 ?
  m01 real4 ?
  m02 real4 ?
  m03 real4 ?
  m10 real4 ?
  m11 real4 ?
  m12 real4 ?
  m13 real4 ?
  m20 real4 ?
  m21 real4 ?
  m22 real4 ?
  m23 real4 ?
  m30 real4 ?
  m31 real4 ?
  m32 real4 ?
  m33 real4 ?
D3DXMATRIX ends
LPD3DXMATRIX typedef ptr D3DXMATRIX

; 
; Quaternions

D3DXQUATERNION struct
  x real4 ?
  y real4 ?
  z real4 ?
  w real4 ?
D3DXQUATERNION ends
LPD3DXQUATERNION typedef ptr D3DXQUATERNION

; 
; Planes

D3DXPLANE struct
  x real4 ?
  y real4 ?
  z real4 ?
  w real4 ?
D3DXPLANE ends
LPD3DXPLANE typedef ptr D3DXPLANE

; 
; Colors

D3DXCOLOR struct
  r real4 ?
  g real4 ?
  b real4 ?
  a real4 ?
D3DXCOLOR ends
LPD3DXCOLOR typedef ptr D3DXCOLOR


; ==================================================================================================
; D3DX math functions:
;
; Note:
; * All these functions can take the same object as in and out parameters.
;
; * Out parameters are typically also returned as return values, so that
;   the output of one function may be used as a parameter to another.
;

; 
; 2D Vector
D3DXVec2CatmullRom					        proto :dword,:dword,:dword,:dword,:dword,:dword
D3DXVec2Length                      proto :dword
D3DXVec2LengthSq                    proto :dword
D3DXVec2Dot                         proto :dword,:dword
D3DXVec2CCW                         proto :dword,:dword ; Z component of ((x1,y1,0) cross (x2,y2,0))
D3DXVec2Add                         proto :dword,:dword,:dword
D3DXVec2Subtract                    proto :dword,:dword,:dword
; Minimize each component.  x = min(x1, x2), y = min(y1, y2)
D3DXVec2Minimize                    proto :dword,:dword,:dword
; Maximize each component.  x = max(x1, x2), y = max(y1, y2)
D3DXVec2Maximize                    proto :dword,:dword,:dword
D3DXVec2Scale                       proto :dword,:dword,:real4
; Linear interpolation. V1 + s(V2-V1)
D3DXVec2Lerp                        proto :dword,:dword,:dword,:real4
D3DXVec2Normalize                   proto :dword,:dword
; Hermite interpolation between position V1, tangent T1 (when s == 0)
; and position V2, tangent T2 (when s == 1).
D3DXVec2Hermite                     proto :dword,:dword,:dword,:dword,:dword,:real4
; Barycentric coordinates.  V1 + f(V2-V1) + g(V3-V1)
D3DXVec2BaryCentric                 proto :dword,:dword,:dword,:dword,:real4,:real4
; Transform (x, y, 0, 1) by matrix.
D3DXVec2Transform                   proto :dword,:dword,:dword
; Transform (x, y, 0, 1) by matrix, project result back into w=1.
D3DXVec2TransformCoord              proto :dword,:dword,:dword
; Transform (x, y, 0, 0) by matrix.
D3DXVec2TransformNormal             proto :dword,:dword,:dword

; 
; 3D Vector
D3DXVec3CatmullRom					        proto :dword,:dword,:dword,:dword,:dword,:dword
D3DXVec3Length                      proto :dword
D3DXVec3LengthSq                    proto :dword
D3DXVec3Dot                         proto :dword,:dword
D3DXVec3Cross                       proto :dword,:dword,:dword
D3DXVec3Add                         proto :dword,:dword,:dword
D3DXVec3Subtract                    proto :dword,:dword,:dword
; Minimize each component.  x = min(x1, x2), y = min(y1, y2), ...
D3DXVec3Minimize                    proto :dword,:dword,:dword
; Maximize each component.  x = max(x1, x2), y = max(y1, y2), ...
D3DXVec3Maximize                    proto :dword,:dword,:dword
D3DXVec3Scale                       proto :dword,:dword,:real4
; Linear interpolation. V1 + s(V2-V1)
D3DXVec3Lerp                        proto :dword,:dword,:dword,:real4
D3DXVec3Normalize                   proto :dword,:dword
; Hermite interpolation between position V1, tangent T1 (when s == 0)
; and position V2, tangent T2 (when s == 1).
D3DXVec3Hermite                     proto :dword,:dword,:dword,:dword,:dword,:real4
; Barycentric coordinates.  V1 + f(V2-V1) + g(V3-V1)
D3DXVec3BaryCentric                 proto :dword,:dword,:dword,:dword,:real4,:real4
; Transform (x, y, z, 1) by matrix.
D3DXVec3Transform                   proto :dword,:dword,:dword
; Transform (x, y, z, 1) by matrix, project result back into w=1.
D3DXVec3TransformCoord              proto :dword,:dword,:dword
; Transform (x, y, z, 0) by matrix.
D3DXVec3TransformNormal             proto :dword,:dword,:dword
D3DXVec3Project                     proto :dword,:dword,:dword,:dword,:dword,:dword
D3DXVec3Unproject                   proto :dword,:dword,:dword,:dword,:dword,:dword

; 
; 4D Vector
D3DXVec4CatmullRom					        proto :dword,:dword,:dword,:dword,:dword,:dword
D3DXVec4Length                      proto :dword
D3DXVec4LengthSq                    proto :dword
D3DXVec4Dot                         proto :dword,:dword
D3DXVec4Add                         proto :dword,:dword,:dword
D3DXVec4Subtract                    proto :dword,:dword,:dword
; Minimize each component.  x = min(x1, x2), y = min(y1, y2), ...
D3DXVec4Minimize                    proto :dword,:dword,:dword
; Maximize each component.  x = max(x1, x2), y = max(y1, y2), ...
D3DXVec4Maximize                    proto :dword,:dword,:dword
D3DXVec4Scale                       proto :dword,:dword,:real4
; Linear interpolation. V1 + s(V2-V1)
D3DXVec4Lerp                        proto :dword,:dword,:dword,:real4
; Cross-product in 4 dimensions.
D3DXVec4Cross                       proto :dword,:dword,:dword,:dword
D3DXVec4Normalize                   proto :dword,:dword
; Hermite interpolation between position V1, tangent T1 (when s == 0)
; and position V2, tangent T2 (when s == 1).
D3DXVec4Hermite                     proto :dword,:dword,:dword,:dword,:dword,:real4
; Barycentric coordinates.  V1 + f(V2-V1) + g(V3-V1)
D3DXVec4BaryCentric                 proto :dword,:dword,:dword,:dword,:real4,:real4
; Transform vector by matrix.
D3DXVec4Transform                   proto :dword,:dword,:dword

; 
; 4D Matrix

D3DXMatrixIdentity                  proto :dword
D3DXMatrixIsIdentity                proto :dword
D3DXMatrixDeterminant               proto :dword
D3DXMatrixfDeterminant  equ <D3DXMatrixDeterminant>
; Matrix multiplication.  The result represents the transformation M2
; followed by the transformation M1.  (Out = M1 * M2)
D3DXMatrixMultiply                  proto :dword,:dword,:dword
D3DXMatrixTranspose                 proto :dword,:dword
; Calculate inverse of matrix.  Inversion my fail, in which case NULL will
; be returned.  The determinant of pM is also returned it pfDeterminant
; is non-NULL.
D3DXMatrixInverse                   proto :dword,:dword,:dword
; Build a matrix which scales by (sx, sy, sz)
D3DXMatrixScaling                   proto :dword,:real4,:real4,:real4
; Build a matrix which translates by (x, y, z)
D3DXMatrixTranslation               proto :dword,:real4,:real4,:real4
; Build a matrix which rotates around the X axis
D3DXMatrixRotationX                 proto :dword,:real4
; Build a matrix which rotates around the Y axis
D3DXMatrixRotationY                 proto :dword,:real4
; Build a matrix which rotates around the Z axis
D3DXMatrixRotationZ                 proto :dword,:real4
; Build a matrix which rotates around an arbitrary axis
D3DXMatrixRotationAxis              proto :dword,:dword,:real4
; Build a matrix from a quaternion
D3DXMatrixRotationQuaternion        proto :dword,:dword
; Yaw around the Y axis, a pitch around the X axis, and a roll around the Z axis.
D3DXMatrixRotationYawPitchRoll      proto :dword,:real4,:real4,:real4
; Build transformation matrix.  NULL arguments are treated as identity.
; Mout = Msc-1 * Msr-1 * Ms * Msr * Msc * Mrc-1 * Mr * Mrc * Mt
D3DXMatrixTransformation            proto :dword,:dword,:dword,:dword,:dword,:dword,:dword
; Build affine transformation matrix.  NULL arguments are treated as identity.
; Mout = Ms * Mrc-1 * Mr * Mrc * Mt
D3DXMatrixAffineTransformation      proto :dword,:real4,:dword,:dword,:dword
; Build a lookat matrix. (right-handed)
D3DXMatrixLookAt                    proto :dword,:dword,:dword,:dword
; Build a lookat matrix. (left-handed)
D3DXMatrixLookAtLH                  proto :dword,:dword,:dword,:dword
; Build a perspective projection matrix. (right-handed)
D3DXMatrixPerspective               proto :dword,:real4,:real4,:real4,:real4
; Build a perspective projection matrix. (left-handed)
D3DXMatrixPerspectiveLH             proto :dword,:real4,:real4,:real4,:real4
; Build a perspective projection matrix. (right-handed)
D3DXMatrixPerspectiveFov            proto :dword,:real4,:real4,:real4,:real4
; Build a perspective projection matrix. (left-handed)
D3DXMatrixPerspectiveFovLH          proto :dword,:real4,:real4,:real4,:real4
; Build a perspective projection matrix. (right-handed)
D3DXMatrixPerspectiveOffCenter      proto :dword,:real4,:real4,:real4,:real4,:real4,:real4
; Build a perspective projection matrix. (left-handed)
D3DXMatrixPerspectiveOffCenterLH    proto :dword,:real4,:real4,:real4,:real4,:real4,:real4
; Build an ortho projection matrix. (right-handed)
D3DXMatrixOrtho                     proto :dword,:real4,:real4,:real4,:real4
; Build an ortho projection matrix. (left-handed)
D3DXMatrixOrthoLH                   proto :dword,:real4,:real4,:real4,:real4
; Build an ortho projection matrix. (right-handed)
D3DXMatrixOrthoOffCenter            proto :dword,:real4,:real4,:real4,:real4,:real4,:real4
; Build an ortho projection matrix. (left-handed)
D3DXMatrixOrthoOffCenterLH          proto :dword,:real4,:real4,:real4,:real4,:real4,:real4
; Build a matrix which flattens geometry into a plane, as if casting a shadow from a light.
D3DXMatrixShadow                    proto :dword,:dword,:dword
; Build a matrix which reflects the coordinate system about a plane
D3DXMatrixReflect                   proto :dword,:dword

; 
; Quaternion

D3DXQuaternionLength                proto :dword
D3DXQuaternionLengthSq              proto :dword
D3DXQuaternionDot                   proto :dword,:dword
D3DXQuaternionIdentity              proto :dword; (0, 0, 0, 1)
D3DXQuaternionIsIdentity            proto :dword
D3DXQuaternionConjugate             proto :dword,:dword; (-x, -y, -z, w)
; Compute a quaternin's axis and angle of rotation. Expects unit quaternions.
D3DXQuaternionToAxisAngle           proto :dword,:dword,:real4
; Build a quaternion from a rotation matrix.
D3DXQuaternionRotationMatrix        proto :dword,:dword
; Rotation about arbitrary axis.
D3DXQuaternionRotationAxis          proto :dword,:dword,:real4
; Yaw around the Y axis, a pitch around the X axis,
; and a roll around the Z axis.
D3DXQuaternionRotationYawPitchRoll  proto :dword,:real4,:real4,:real4
; Quaternion multiplication.  The result represents the rotation Q2
; followed by the rotation Q1.  (Out = Q2 * Q1)
D3DXQuaternionMultiply              proto :dword,:dword,:dword
D3DXQuaternionNormalize             proto :dword,:dword
; Conjugate and re-norm
D3DXQuaternionInverse               proto :dword,:dword
; Expects unit quaternions.
; if q = (cos(theta), sin(theta) * v); ln(q) = (0, theta * v)
D3DXQuaternionLn                    proto :dword,:dword
; Expects pure quaternions. (w == 0)  w is ignored in calculation.
; if q = (0, theta * v); exp(q) = (cos(theta), sin(theta) * v)
D3DXQuaternionExp                   proto :dword,:dword
; Spherical linear interpolation between Q1 (s == 0) and Q2 (s == 1).
; Expects unit quaternions.
D3DXQuaternionSlerp                 proto :dword,:dword,:dword,:real4
; Spherical quadrangle interpolation.
; Slerp(Slerp(Q1, Q4, t), Slerp(Q2, Q3, t), 2t(1-t))
D3DXQuaternionSquad                 proto :dword,:dword,:dword,:dword,:dword,:real4
; Slerp(Slerp(Q1, Q2, f+g), Slerp(Q1, Q3, f+g), g/(f+g))
D3DXQuaternionBaryCentric           proto :dword,:dword,:dword,:dword,:real4,:real4

; 
; Plane

; ax + by + cz + dw
D3DXPlaneDot                        proto :dword,:dword
; ax + by + cz + d
D3DXPlaneDotCoord                   proto :dword,:dword
; ax + by + cz
D3DXPlaneDotNormal                  proto :dword,:dword
; Normalize plane (so that |a,b,c| == 1)
D3DXPlaneNormalize                  proto :dword,:dword
; Find the intersection between a plane and a line.  If the line is
; parallel to the plane, NULL is returned.
D3DXPlaneIntersectLine              proto :dword,:dword,:dword,:dword
; Construct a plane from a point and a normal
D3DXPlaneFromPointNormal            proto :dword,:dword,:dword
; Construct a plane from 3 points
D3DXPlaneFromPoints                 proto :dword,:dword,:dword,:dword
; Transform a plane by a matrix.  The vector (a,b,c) must be normal.
; M must be an affine transform.
D3DXPlaneTransform                  proto :dword,:dword,:dword

; 
; Color

; (1-r, 1-g, 1-b, a)
D3DXColorNegative                   proto :dword,:dword
D3DXColorAdd                        proto :dword,:dword,:dword
D3DXColorSubtract                   proto :dword,:dword,:dword
D3DXColorScale                      proto :dword,:dword,:real4
; (r1*r2, g1*g2, b1*b2, a1*a2)
D3DXColorModulate                   proto :dword,:dword,:dword
; Linear interpolation of r,g,b, and a. C1 + s(C2-C1)
D3DXColorLerp                       proto :dword,:dword,:dword,:real4
; Interpolate r,g,b between desaturated color and color.
; DesaturatedColor + s(Color - DesaturatedColor)
D3DXColorAdjustSaturation           proto :dword,:dword,:real4
; Interpolate r,g,b between 50% grey and color.  Grey + s(Color - Grey)
D3DXColorAdjustContrast             proto :dword,:dword,:real4


; 
; Matrix Stack

D3DXCreateMatrixStack               proto :dword,:dword

ID3DXMatrixStack struct
STDMETHOD  QueryInterface , :DWORD, :DWORD, :DWORD
STDMETHOD  AddRef , :DWORD
STDMETHOD  Release , :DWORD
STDMETHOD  _Pop , :DWORD
STDMETHOD  _Push, :DWORD
STDMETHOD  LoadIdentity , :DWORD
STDMETHOD  LoadMatrix , :DWORD, :DWORD
STDMETHOD  MultMatrix , :DWORD, :DWORD
STDMETHOD  MultMatrixLocal , :DWORD, :DWORD
STDMETHOD  RotateAxis , :DWORD, :DWORD, :DWORD
STDMETHOD  RotateAxisLocal , :DWORD, :DWORD, :DWORD
STDMETHOD  RotateYawPitchRoll , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  RotateYawPitchRollLocal , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  Scale , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  ScaleLocal , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  Translate , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  TranslateLocal , :DWORD, :DWORD, :DWORD, :DWORD
STDMETHOD  GetTop , :DWORD
ID3DXMatrixStack ends